VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Bucket"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim parent As frmMain
Dim c_isfilling As Boolean
Dim undoch As Changes

Dim usewalltile As Boolean

Public Property Get isFilling() As Boolean
    isFilling = c_isfilling
End Property

Sub setParent(main As frmMain)
    Set parent = main
End Sub

Sub MouseDown(Button As Integer, x As Single, y As Single)
    Dim curtilex As Integer
    Dim curtiley As Integer
    On Error GoTo MouseDown_Error

    curtilex = (Int(((parent.hScr.value + x)) / (parent.currenttilew)))
    curtiley = (Int(((parent.vScr.value + y)) / (parent.currenttilew)))
    If (curtilex < 0 Or curtiley < 0 Or curtilex > 1023 Or curtiley > 1023) Then
        Exit Sub
    End If

    Dim tmptile As Integer
    If Button = vbLeftButton Then
        tmptile = parent.tilesetleft
        usewalltile = parent.useWallTileLeft
        parent.walltiles.curwall = parent.curWallTileLeft
    Else
        tmptile = parent.tilesetright
        usewalltile = parent.useWallTileRight
        parent.walltiles.curwall = parent.curWallTileRight
    End If

    If tmptile = 217 Or tmptile = 219 Or tmptile = 220 Then

        Exit Sub
    End If

    Dim fillinselectiononly As Boolean
    fillinselectiononly = (parent.sel.hasAlreadySelectedParts)

    If fillinselectiononly And Not parent.sel.getIsInSelection(curtilex, curtiley) Then
        'if we have a selection, but didn't click in it
        'do nothing
        Exit Sub
    End If

    If Not fillinselectiononly Then
        parent.undoredo.ResetRedo
        Set undoch = New Changes
    End If

    Dim sourcetilenr As Integer
    If parent.sel.getIsInSelection(curtilex, curtiley) Then
        sourcetilenr = parent.sel.getSelTile(curtilex, curtiley)
        If sourcetilenr = -1 Then
            sourcetilenr = SearchSelObjectNr(parent, curtilex, curtiley)
        End If
    Else
        sourcetilenr = parent.getTile(curtilex, curtiley)
        If sourcetilenr = -1 Then
            sourcetilenr = SearchObjectNr(parent, curtilex, curtiley)
        End If
    End If

    'filling in special tiles not working properly for now, just abort
    If sourcetilenr = -1 Or sourcetilenr = 217 Or sourcetilenr = 219 Or sourcetilenr = 220 Then
        Exit Sub
    End If

    'If isTileSpecial(parent, curtilex, curtiley) Then
    '    Call SearchAndDestroyObject(parent, curtilex, curtiley, undoch, False, sourcetilenr)
    'End If

    If usewalltile Then
        Call parent.walltiles.ClearIsWallTile
        Call Fill(sourcetilenr, tmptile, curtilex, curtiley, undoch, fillinselectiononly, parent.fillinscreen, , True)
    End If
    Call Fill(sourcetilenr, tmptile, curtilex, curtiley, undoch, fillinselectiononly, parent.fillinscreen)
    parent.mapchanged = True

    '    If undoch <> "" Then
    Call parent.undoredo.AddToUndo(undoch)
    '    Else
    '        Call parent.undoredo.ResetUndo
    '    End If

    On Error GoTo 0
    Exit Sub

MouseDown_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure MouseDown of Class Module Bucket"
End Sub

Sub MouseMove()
'no way we're using bucket at move, it will crash like hell
End Sub

Sub MouseUp()
'nothing to do on up
End Sub

Sub Fill(tilenr As Integer, fillnr As Integer, ByVal x As Integer, ByVal y As Integer, undoch As Changes, Optional fillinselection = False, Optional fillscreenonly = True, Optional ByVal stack As Long = 50000, Optional tagwalltiles As Boolean = False)
    On Error GoTo Fill_Error

    parent.MousePointer = vbHourglass
    c_isfilling = True

    Dim done(1023, 1023) As Boolean
    Dim px() As Long
    Dim py() As Long
    Dim Pstart As Long
    Dim Pstop As Long
    Dim Pcount As Long
    Dim Colour As Integer

    Dim Lx As Integer
    Dim Ly As Integer

    Dim Sloop As Long
    ReDim px(0)
    ReDim py(0)

    Dim fillingspecial As Boolean
    If tilenr = 217 Or tilenr = 219 Or tilenr = 220 Then
        fillingspecial = True
    Else
        fillingspecial = False
    End If

    Lx = x
    Ly = y

    Pstart = 0
    Pstop = 0
    px(0) = Lx
    py(0) = Ly
    Dim count As Long

    Dim lbsx As Integer
    Dim lbsy As Integer
    Dim hbsx As Integer
    Dim hbsy As Integer
    lbsx = Int(parent.hScr.value / (parent.currenttilew))
    hbsx = Int((parent.hScr.value + parent.picpreview.Width) / (parent.currenttilew))
    lbsy = Int(parent.vScr.value / (parent.currenttilew))
    hbsy = Int((parent.vScr.value + parent.picpreview.Height) / (parent.currenttilew))

    GoSub AddPoints
    While Pstart < Pstop

        Lx = px(Pstart)
        Ly = py(Pstart)
        If Not (Lx < 0 Or Ly < 0 Or Lx > 1023 Or Ly > 1023) Then
            If fillinselection Then
                If Not parent.sel.getIsInSelection(Lx, Ly) Then
                    GoTo skiploop
                End If
            ElseIf Not fillinselection And fillscreenonly Then
                If (Lx < lbsx Or Ly < lbsy Or Lx > hbsx Or Ly > hbsy) Then
                    GoTo skiploop
                End If
            End If

            If parent.sel.getIsInSelection(Lx, Ly) Then
                Colour = parent.sel.getSelTile(Lx, Ly)
            Else
                Colour = parent.getTile(Lx, Ly)
            End If

            If Colour = -1 And fillingspecial Then
                If fillinselection Then
                    Colour = SearchSelObjectNr(parent.sel, Lx, Ly)
                Else
                    Colour = SearchObjectNr(parent, Lx, Ly)
                End If
                If Colour = -1 Then
                    Colour = tilenr
                End If
            End If

            If Not (done(Lx, Ly) = True Or Colour <> tilenr) Then
                Pcount = Pcount + 1
                done(Lx, Ly) = True

                count = count + 1

                If tagwalltiles Then
                    Call parent.walltiles.setIsWallTile(Lx, Ly)
                Else
                    If usewalltile Then
                        fillnr = parent.walltiles.DrawWallTile(Lx, Ly, True, undoch, False, True)
                    End If
                    If fillinselection Then
                        Call parent.sel.setSelTile(Lx, Ly, fillnr)
                    Else
                        Call parent.setTile(Lx, Ly, fillnr, undoch, True)
                    End If
                End If
                'it will prolly go faster if we directly set the pixel to the
                'pixel map, rather than calling updateleveltile,
                'becuase updateleveltile also calculates if it falls
                'in preview, which in unnecessary

                'Call SetPixel(parent.pic1024.hdc, Lx, Ly, TilePixelColor(parent.getTile(x, y)))
                'Call parent.Set1024Pixel(Lx, Ly, TilePixelColor(parent.getTile(X, Y)))
                If Not fillinselection Then
                    Call parent.UpdateLevelTile(Lx, Ly, False)
                End If
                '                piccurrent.PSet (Lx, Ly), vbblue
                '  DoEvents
                GoSub AddPoints
            End If
        End If
skiploop:
        Pstart = Pstart + 1

    Wend
    'but because we handled it directly, we need to update the level
    'too,not only the preview
    If Not tagwalltiles Then Call parent.UpdateLevel
    c_isfilling = False

    parent.MousePointer = 0
    Exit Sub

AddPoints:

    If Pstart > stack Then
        For Sloop = Pstart To Pstop
            px(Sloop - stack) = px(Sloop)
            py(Sloop - stack) = py(Sloop)
        Next Sloop
        ReDim Preserve px(Pstop - stack)
        ReDim Preserve py(Pstop - stack)
        Pstart = Pstart - stack
        Pstop = Pstop - stack
    End If
    ReDim Preserve px(Pstop + 4)
    ReDim Preserve py(Pstop + 4)
    Pstop = Pstop + 1
    px(Pstop) = Lx + 1
    py(Pstop) = Ly
    Pstop = Pstop + 1
    px(Pstop) = Lx
    py(Pstop) = Ly + 1
    Pstop = Pstop + 1
    px(Pstop) = Lx - 1
    py(Pstop) = Ly
    Pstop = Pstop + 1
    px(Pstop) = Lx
    py(Pstop) = Ly - 1

    Return
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


    On Error GoTo 0
    Exit Sub

Fill_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure Fill of Class Module Bucket"

End Sub

