VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Line"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim parent As frmMain

Dim startlinex As Integer
Dim startliney As Integer
Dim endlinex As Integer
Dim endliney As Integer

Public usewalltile As Boolean

Dim undoch As Changes

Dim oldtilex As Integer
Dim oldtiley As Integer

Dim objfound As Boolean
    
Public linew As Integer

Private Sub Class_Initialize()
    linew = 1
End Sub

Sub setParent(main As frmMain)
    Set parent = main
End Sub

Sub MouseDown(Button As Integer, x As Single, y As Single, Optional Shift As Integer)
    Dim curtilex As Integer
    Dim curtiley As Integer
    On Error GoTo MouseDown_Error

    curtilex = (parent.hScr.value + x) \ parent.currenttilew
    curtiley = (parent.vScr.value + y) \ parent.currenttilew

    If curtilex < 0 Then curtilex = 0
    If curtiley < 0 Then curtiley = 0
    If curtilex > 1023 Then curtilex = 1023
    If curtiley > 1023 Then curtiley = 1023


    Dim tmptile As Integer
    Dim tmpTileSizeX As Integer
    Dim tmpTileSizeY As Integer
    If Button = vbLeftButton Then
        tmptile = parent.tilesetleft
        tmpTileSizeX = parent.multTileLeftx
        tmpTileSizeY = parent.multTileLefty
        usewalltile = parent.useWallTileLeft
        parent.walltiles.curwall = parent.curWallTileLeft
    ElseIf Button = vbRightButton Then
        tmptile = parent.tilesetright
        tmpTileSizeX = parent.multTileRightx
        tmpTileSizeY = parent.multTileRighty
        usewalltile = parent.useWallTileRight
        parent.walltiles.curwall = parent.curWallTileRight
    Else
        Exit Sub
    End If

    If (tmptile = 217 Or tmptile = 219 Or tmptile = 220) Then
        If curtool = T_ellipse Or curtool = T_filledellipse Then
            Call parent.pencil.MouseDown(Button, x, y)
            Exit Sub
        End If
    End If

    
    parent.undoredo.ResetRedo
    Set undoch = New Changes
    

    startlinex = curtilex
    startliney = curtiley

    If usewalltile Then
        Call parent.walltiles.ClearIsWallTile
        If SharedVar.curtool = T_line Then
            Call DrawLine(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, False, , , , True)
        ElseIf SharedVar.curtool = T_rectangle Then
            Call DrawTileRectangle(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, False, , , True)
        ElseIf SharedVar.curtool = T_filledrectangle Then
            Call DrawTileRectangle(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, True, , , True)
        ElseIf SharedVar.curtool = T_ellipse Then
            Call DrawEllipse(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, , , , True)
        ElseIf SharedVar.curtool = T_filledellipse Then
            Call DrawEllipse(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, True, , , True)
        End If
    End If

    If SharedVar.curtool = T_line Then
        Call DrawLine(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, True, False)
    ElseIf SharedVar.curtool = T_rectangle Or SharedVar.curtool = T_filledrectangle Then
        Call DrawTileRectangle(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, True, False)
    ElseIf SharedVar.curtool = T_ellipse Or SharedVar.curtool = T_filledellipse Then
        Call DrawEllipse(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, True, False)
    End If
    parent.mapchanged = True

    oldtilex = curtilex
    oldtiley = curtiley

    On Error GoTo 0
    Exit Sub

MouseDown_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure MouseDown of Class Module Line"
End Sub

Sub MouseMove(Button As Integer, x As Single, y As Single, origX As Single, origY As Single, step As Integer, Optional usingctrl As Boolean)
    Dim curtilex As Integer
    Dim curtiley As Integer
    Dim fromtilex As Integer
    Dim fromtiley As Integer
    Dim tempx1 As Integer
    Dim tempy1 As Integer
    Dim oldusectrl As Boolean

    On Error GoTo MouseMove_Error

    If Not SharedVar.MouseDown Then
        Exit Sub
    End If

    curtilex = (parent.hScr.value + x) \ parent.currenttilew
    curtiley = (parent.vScr.value + y) \ parent.currenttilew

    If oldtilex = curtilex And oldtiley = curtiley And oldusectrl = usingctrl Then
        Exit Sub
    End If

    Dim tmptile As Integer
    Dim tmpTileSizeX As Integer
    Dim tmpTileSizeY As Integer
    If Button = vbLeftButton Then
        tmptile = parent.tilesetleft
        tmpTileSizeX = parent.multTileLeftx
        tmpTileSizeY = parent.multTileLefty
        usewalltile = parent.useWallTileLeft
        parent.walltiles.curwall = parent.curWallTileLeft
    ElseIf Button = vbRightButton Then
        tmptile = parent.tilesetright
        tmpTileSizeX = parent.multTileRightx
        tmpTileSizeY = parent.multTileRighty
        usewalltile = parent.useWallTileRight
        parent.walltiles.curwall = parent.curWallTileRight
    Else
        Exit Sub
    End If

    If (tmptile = 217 Or tmptile = 219 Or tmptile = 220) Then
        If curtool = T_ellipse Or curtool = T_filledellipse Then
            Exit Sub
        Else
            If GetMaxSizeOfObject(tmptile) > step Then step = GetMaxSizeOfObject(tmptile)
        End If
    End If


        
    tempx1 = startlinex
    tempy1 = startliney

    If usingctrl Then
        fromtilex = (parent.hScr.value + origX) \ parent.currenttilew
        fromtiley = (parent.vScr.value + origY) \ parent.currenttilew

        startlinex = fromtilex - (curtilex - fromtilex)
        startliney = fromtiley - (curtiley - fromtiley)
    Else
        startlinex = tempx1
        startliney = tempy1
    End If

    If (curtilex < 0 Or curtiley < 0 Or curtilex > 1023 Or curtiley > 1023 Or _
        startlinex < 0 Or startliney < 0 Or startlinex > 1023 Or startliney > 1023) Then

        If parent.tline.linew <> 1 Then
            If curtilex - (parent.tline.linew \ 2) < 0 Then curtilex = (parent.tline.linew \ 2) - 1
            If curtiley - (parent.tline.linew \ 2) < 0 Then curtiley = (parent.tline.linew \ 2) - 1
            If curtilex + (parent.tline.linew \ 2) > 1023 Then curtilex = 1023 - (parent.tline.linew \ 2)
            If curtiley + (parent.tline.linew \ 2) > 1023 Then curtiley = 1023 - (parent.tline.linew \ 2)
            If startlinex - (parent.tline.linew \ 2) < 0 Then startlinex = (parent.tline.linew \ 2) - 1
            If startliney - (parent.tline.linew \ 2) < 0 Then startliney = (parent.tline.linew \ 2) - 1
            If startlinex + (parent.tline.linew \ 2) > 1023 Then startlinex = 1023 - (parent.tline.linew \ 2)
            If startliney + (parent.tline.linew \ 2) > 1023 Then startliney = 1023 - (parent.tline.linew \ 2)
        Else
            If curtilex < 0 Then curtilex = 0
            If curtiley < 0 Then curtiley = 0
            If curtilex > 1023 Then curtilex = 1023
            If curtiley > 1023 Then curtiley = 1023
            If startlinex < 0 Then startlinex = 0
            If startliney < 0 Then startliney = 0
            If startlinex > 1023 Then startlinex = 1023
            If startliney > 1023 Then startliney = 1023
        End If
    End If




    If endlinex = curtilex And endliney = curtiley Then
        Exit Sub
    End If

    Call parent.UpdatePreview(False)


    'Tag walltiles if needed
    If usewalltile Then
        Call parent.walltiles.ClearIsWallTile
        If SharedVar.curtool = T_line Then
            Call DrawLine(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, False, , , step, True)
        ElseIf SharedVar.curtool = T_rectangle Then
            Call DrawTileRectangle(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, False, , step, True)
        ElseIf SharedVar.curtool = T_filledrectangle Then
            Call DrawTileRectangle(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, True, , step, True)
        ElseIf SharedVar.curtool = T_ellipse Then
            Call DrawEllipse(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, , , step, True)
        ElseIf SharedVar.curtool = T_filledellipse Then
            Call DrawEllipse(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, True, , step, True)
        End If
    End If




    If SharedVar.curtool = T_line Then
        Call DrawLine(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, True, , , step)
    ElseIf SharedVar.curtool = T_rectangle Then
        Call DrawTileRectangle(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, False, , step)
    ElseIf SharedVar.curtool = T_filledrectangle Then
        Call DrawTileRectangle(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, True, , step)
    ElseIf SharedVar.curtool = T_ellipse Then
        Call DrawEllipse(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, , , step)
    ElseIf SharedVar.curtool = T_filledellipse Then
        Call DrawEllipse(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, True, , step)
    End If

    startlinex = tempx1
    startliney = tempy1
    
        oldtilex = curtilex
        oldtiley = curtiley
        oldusectrl = usingctrl
        
    On Error GoTo 0
    Exit Sub

MouseMove_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure MouseMove of Class Module Line"

End Sub

Sub MouseUp(Button As Integer, x As Single, y As Single, origX As Single, origY As Single, step As Integer, Optional usingctrl As Boolean)
    Dim curtilex As Integer
    Dim curtiley As Integer
    Dim fromtilex As Integer
    Dim fromtiley As Integer
    Dim tempx1 As Integer
    Dim tempy1 As Integer


    On Error GoTo MouseUp_Error

    curtilex = (parent.hScr.value + x) \ parent.currenttilew
    curtiley = (parent.vScr.value + y) \ parent.currenttilew

    Dim tmptile As Integer
    Dim tmpTileSizeX As Integer
    Dim tmpTileSizeY As Integer
    If Button = vbLeftButton Then
        tmptile = parent.tilesetleft
        tmpTileSizeX = parent.multTileLeftx
        tmpTileSizeY = parent.multTileLefty
        usewalltile = parent.useWallTileLeft
        parent.walltiles.curwall = parent.curWallTileLeft
    ElseIf Button = vbRightButton Then
        tmptile = parent.tilesetright
        tmpTileSizeX = parent.multTileRightx
        tmpTileSizeY = parent.multTileRighty
        usewalltile = parent.useWallTileRight
        parent.walltiles.curwall = parent.curWallTileRight
    Else
        Exit Sub
    End If

    If (tmptile = 217 Or tmptile = 219 Or tmptile = 220) Then
        If curtool = T_ellipse Or curtool = T_filledellipse Then
            Exit Sub
        Else
            Dim objsize As Integer
            objsize = GetMaxSizeOfObject(tmptile)
            If objsize > step Then step = objsize
        End If
    End If

    tempx1 = startlinex
    tempy1 = startliney

    If usingctrl Then
        fromtilex = (parent.hScr.value + origX) \ parent.currenttilew
        fromtiley = (parent.vScr.value + origY) \ parent.currenttilew

        startlinex = fromtilex - (curtilex - fromtilex)
        startliney = fromtiley - (curtiley - fromtiley)
    Else
        startlinex = tempx1
        startliney = tempy1
    End If

    If (curtilex < 0 Or curtiley < 0 Or curtilex > 1023 Or curtiley > 1023 Or _
        startlinex < 0 Or startliney < 0 Or startlinex > 1023 Or startliney > 1023) Then

        If parent.tline.linew <> 1 Then
            If curtilex - (parent.tline.linew \ 2) < 0 Then curtilex = (parent.tline.linew \ 2) - 1
            If curtiley - (parent.tline.linew \ 2) < 0 Then curtiley = (parent.tline.linew \ 2) - 1
            If curtilex + (parent.tline.linew \ 2) > 1023 Then curtilex = 1023 - (parent.tline.linew \ 2)
            If curtiley + (parent.tline.linew \ 2) > 1023 Then curtiley = 1023 - (parent.tline.linew \ 2)
            If startlinex - (parent.tline.linew \ 2) < 0 Then startlinex = (parent.tline.linew \ 2) - 1
            If startliney - (parent.tline.linew \ 2) < 0 Then startliney = (parent.tline.linew \ 2) - 1
            If startlinex + (parent.tline.linew \ 2) > 1023 Then startlinex = 1023 - (parent.tline.linew \ 2)
            If startliney + (parent.tline.linew \ 2) > 1023 Then startliney = 1023 - (parent.tline.linew \ 2)
        Else
            If curtilex < 0 Then curtilex = 0
            If curtiley < 0 Then curtiley = 0
            If curtilex > 1023 Then curtilex = 1023
            If curtiley > 1023 Then curtiley = 1023
            If startlinex < 0 Then startlinex = 0
            If startliney < 0 Then startliney = 0
            If startlinex > 1023 Then startlinex = 1023
            If startliney > 1023 Then startliney = 1023
        End If
    End If



    If usewalltile Then
        Call parent.walltiles.ClearIsWallTile
        If SharedVar.curtool = T_line Then
            Call DrawLine(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, False, , , step, True)
        ElseIf SharedVar.curtool = T_rectangle Then
            Call DrawTileRectangle(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, False, , step, True)
        ElseIf SharedVar.curtool = T_filledrectangle Then
            Call DrawTileRectangle(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, True, , step, True)
        ElseIf SharedVar.curtool = T_ellipse Then
            Call DrawEllipse(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, , , step, True)
        ElseIf SharedVar.curtool = T_filledellipse Then
            Call DrawEllipse(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, True, , step, True)
        End If
    End If

    If SharedVar.curtool = T_line Then
        Call DrawLine(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, False, , , , step)
    ElseIf SharedVar.curtool = T_rectangle Then
        Call DrawTileRectangle(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, False, False, , step)
    ElseIf SharedVar.curtool = T_filledrectangle Then
        Call DrawTileRectangle(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, False, True, True, step)
    ElseIf SharedVar.curtool = T_ellipse Then
        Call DrawEllipse(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, False, , , step)
    ElseIf SharedVar.curtool = T_filledellipse Then
        Call DrawEllipse(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, False, True, True, step)
    End If

    If parent.magnifier.UsingPixels Then
        parent.UpdateLevel
    Else
        If tmptile = 0 Or tmptile = 256 Then
            parent.UpdateLevel
        Else
            parent.UpdatePreview
        End If
    End If

    Call parent.undoredo.AddToUndo(undoch)

    startlinex = tempx1
    startliney = tempy1

    Call parent.walltiles.ClearIsWallTile
    
    On Error GoTo 0
    Exit Sub

MouseUp_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure MouseUp of Class Module Line"

End Sub

Sub DrawLine(tilenr As Integer, startx As Integer, starty As Integer, endx As Integer, endy As Integer, undoch As Changes, multTileX As Integer, multTileY As Integer, Optional onpreview As Boolean = True, Optional refresh As Boolean = True, Optional appendundo As Boolean = True, Optional ignoreThickness As Boolean = False, Optional step As Integer = 0, Optional tagwalltiles As Boolean = False)
    Dim Width As Integer
    On Error GoTo DrawLine_Error

    Width = linew
    Dim i As Integer
    Dim j As Integer
    Dim a As Integer

    Dim stepX As Integer
    Dim stepY As Integer
    
    If multTileX > step + 1 Then
        stepX = multTileX
    Else
        stepX = step + 1
    End If
    If multTileY > step + 1 Then
        stepY = multTileY
    Else
        stepY = step + 1
    End If
    
    
    Dim tmpendx As Integer
    Dim tmpendy As Integer
    tmpendx = startx + ((endx - startx) \ stepX) * stepX
    tmpendy = starty + ((endy - starty) \ stepY) * stepY
    
    If Abs(tmpendx - startx) - 1 > Abs(tmpendy - starty) Then
        stepY = 1
    ElseIf Abs(tmpendy - starty) - 1 > Abs(tmpendx - startx) Then
        stepX = 1
    End If

    endx = startx + ((endx - startx) \ stepX) * stepX
    endy = starty + ((endy - starty) \ stepY) * stepY

    objfound = False
    
    If tagwalltiles = True Then
        'We're using walltiles, define which tiles will be in the area to tile
        If parent.tline.linew <> 1 And Not ignoreThickness And Not multTileX > 1 And Not multTileY > 1 Then
            For j = -(parent.tline.linew \ 2) + 1 To (parent.tline.linew \ 2)
                For i = -(parent.tline.linew \ 2) + 1 To (parent.tline.linew \ 2)
                    Call DrawBaseLine(1, startx + i, starty + j, endx + i, endy + j, stepX, stepY, undoch, multTileX, multTileY, onpreview, False, appendundo, tagwalltiles = True)
                Next
            Next
        Else
            Call DrawBaseLine(1, startx, starty, endx, endy, stepX, stepY, undoch, multTileX, multTileY, onpreview, refresh, appendundo, True)
        End If

    Else

        If parent.tline.linew <> 1 And Not ignoreThickness And Not multTileX > 1 And Not multTileY > 1 And (tilenr <> 217 And tilenr <> 219 And tilenr <> 220) Then
            For j = -(parent.tline.linew \ 2) + 1 To (parent.tline.linew \ 2)
                For i = -(parent.tline.linew \ 2) + 1 To (parent.tline.linew \ 2)
                    Call DrawBaseLine(tilenr, startx + i, starty + j, endx + i, endy + j, stepX, stepY, undoch, multTileX, multTileY, onpreview, False, appendundo)
                Next
            Next
            If refresh Or objfound Then
                If Not onpreview Then
                    If tilenr = 256 Or tilenr = 0 Then
                        parent.UpdateLevel
                    Else
                        parent.UpdatePreview
                    End If
                Else
                    parent.picpreview.refresh
                End If
            End If
        Else
            Call DrawBaseLine(tilenr, startx, starty, endx, endy, stepX, stepY, undoch, multTileX, multTileY, onpreview, refresh, appendundo)
        End If

    End If

    On Error GoTo 0
    Exit Sub

DrawLine_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure DrawLine of Class Module Line"

End Sub
Sub DrawBaseLine(tilenr As Integer, _
                 startx As Integer, starty As Integer, _
                 endx As Integer, endy As Integer, _
                 stepX As Integer, _
                 stepY As Integer, _
                 undoch As Changes, _
                 multTileX As Integer, _
                 multTileY As Integer, _
                 Optional onpreview As Boolean = True, Optional refresh As Boolean = True, _
                 Optional appendundo As Boolean = True, _
                 Optional tagwalltiles As Boolean = False)



    On Error GoTo DrawBaseLine_Error
    Dim tnr As Integer
    If tilenr = 0 Then tnr = 256 Else tnr = tilenr




    ' Bresenham's line algorithm for Microsoft Visual Basic 6.0
    ' Implementation by Robert Lee  July, 2002 Public Domain


    Dim InitialX As Integer
    Dim InitialY As Integer
    Dim FinalX As Integer
    Dim FinalY As Integer

    Dim i As Integer
    Dim j As Integer

    Dim val As Integer
    Dim tmp As Integer

    InitialX = startx
    InitialY = starty
    
    FinalX = endx
    FinalY = endy
    
    Dim correctStepX As Integer
    Dim correctStepY As Integer
    
    Dim Steep As Boolean
    Dim DeltaX As Integer, DeltaY As Integer, Delta As Integer
    Dim coord As Integer

    Dim distX As Integer
    Dim distY As Integer
    distX = Abs(endx - startx)
    distY = Abs(endy - starty)
    
    DeltaX = distX / stepX
    DeltaY = distY / stepY
    
    Steep = False
    If (FinalX - InitialX) > 0 Then
        correctStepX = stepX
    Else
        correctStepX = -stepX
    End If
    If (FinalY - InitialY) > 0 Then
        correctStepY = stepY
    Else
        correctStepY = -stepY
    End If
    
    If distX < distY Then
        Steep = True
        Swap InitialX, InitialY
        Swap DeltaX, DeltaY
        Swap correctStepX, correctStepY
    End If
    
    Dim lbx As Integer
    Dim lby As Integer
    
    lbx = parent.hScr.value \ parent.currenttilew
    lby = parent.vScr.value \ parent.currenttilew

    Delta = (DeltaY + DeltaY) - DeltaX

    For coord = 0 To DeltaX - 1
            If Steep Then
                Call DrawTiles(tilenr, InitialY, InitialX, lbx, lby, undoch, multTileX, multTileY, onpreview, refresh, appendundo, tagwalltiles)
            Else
                Call DrawTiles(tilenr, InitialX, InitialY, lbx, lby, undoch, multTileX, multTileY, onpreview, refresh, appendundo, tagwalltiles)
            End If

        While Delta >= 0
            InitialY = InitialY + correctStepY
            Delta = Delta - (DeltaX + DeltaX)
            Delta = Delta
        Wend
        InitialX = InitialX + correctStepX
        Delta = Delta + (DeltaY + DeltaY)
    Next coord

    Call DrawTiles(tilenr, FinalX, FinalY, lbx, lby, undoch, multTileX, multTileY, onpreview, refresh, appendundo, tagwalltiles)

    If refresh And Not tagwalltiles Then
        If Not onpreview Then
            If tnr = 256 Then
                parent.UpdateLevel
            Else
                parent.UpdatePreview
            End If
        Else
            parent.picpreview.refresh
        End If
    End If

    On Error GoTo 0
    Exit Sub

DrawBaseLine_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure DrawBaseLine of Class Module Line"

End Sub

Sub DrawTiles(tilenr As Integer, InitialX As Integer, InitialY As Integer, lbx As Integer, lby As Integer, _
              undoch As Changes, _
              multTileX As Integer, _
              multTileY As Integer, _
              Optional onpreview As Boolean = True, Optional refresh As Boolean = True, _
              Optional appendundo As Boolean = True, _
              Optional tagwalltiles As Boolean = False)
    Dim i As Integer
    Dim j As Integer
    Dim m As Integer
    Dim n As Integer
    Dim val As Integer
    Dim tmp As Integer
    Dim tnr As Integer
    

    
    If tilenr = 0 Then tnr = 256 Else tnr = tilenr

    Dim offsetX As Integer
    Dim offsetY As Integer
    offsetX = Int((multTileX - 0.5) / 2)
    offsetY = Int((multTileY - 0.5) / 2)

    SetStretchBltMode parent.picpreview.hdc, HALFTONE
    
    For j = 0 To multTileY - 1
        For i = 0 To multTileX - 1
            Dim curtilex As Integer
            Dim curtiley As Integer
            curtilex = InitialX + i - offsetX
            curtiley = InitialY + j - offsetY

            If curtilex >= 0 And curtiley >= 0 And _
               curtilex < 1024 And curtiley < 1024 Then

                If tagwalltiles Then
                    Call parent.walltiles.setIsWallTile(curtilex, curtiley)
                Else
                    If parent.pastetype <> p_under Or _
                       parent.pastetype = p_under And parent.getTile(curtilex, curtiley) = 0 Then
                        If usewalltile Then
                            tilenr = parent.walltiles.DrawWallTile(curtilex, curtiley, True, undoch, onpreview)
                        End If

                        If Not onpreview Then
                            If isTileSpecial(parent, curtilex, curtiley) Then
                                Call SearchAndDestroyObject(parent, curtilex, curtiley, undoch, False)
                            End If
                            If tilenr = 217 Or tilenr = 219 Or tilenr = 220 Then
                                If isTileSpecial(parent, curtilex, curtiley) Then
                                    objfound = True
                                End If
                                Call setObject(parent, tilenr, curtilex - GetMaxSizeOfObject(tilenr) \ 2, curtiley - GetMaxSizeOfObject(tilenr) \ 2, undoch, False)
                            Else
                                Call parent.setTile(curtilex, curtiley, tilenr + i + 19 * j, undoch, appendundo)
                                Call parent.UpdateLevelTile(curtilex, curtiley, False)
                            End If
                        Else
                            If Not parent.magnifier.UsingPixels Then
                                If tilenr = 217 Then
                                    'SetStretchBltMode parent.picpreview.hdc, HALFTONE
                                    StretchBlt parent.picpreview.hdc, (curtilex - lbx) * (parent.currenttilew), (curtiley - lby) * (parent.currenttilew), 2 * (parent.currenttilew), 2 * (parent.currenttilew), frmGeneral.picspecial.hdc, 16, 0, 2 * TileW, 2 * TileW, vbSrcCopy
                                    'parent.picpreview.refresh
                                ElseIf tilenr = 219 Then
                                    'SetStretchBltMode parent.picpreview.hdc, HALFTONE
                                    StretchBlt parent.picpreview.hdc, (curtilex - lbx - 2) * (parent.currenttilew), (curtiley - lby - 2) * (parent.currenttilew), 6 * (parent.currenttilew), 6 * (parent.currenttilew), frmGeneral.picspecial.hdc, 128, 0, 6 * TileW, 6 * TileW, vbSrcCopy
                                    'parent.picpreview.refresh
                                ElseIf tilenr = 220 Then
                                    'SetStretchBltMode parent.picpreview.hdc, HALFTONE
                                    StretchBlt parent.picpreview.hdc, (curtilex - lbx - 2) * (parent.currenttilew), (curtiley - lby - 2) * (parent.currenttilew), 5 * (parent.currenttilew), 5 * (parent.currenttilew), frmGeneral.picspecial.hdc, 48, 0, 5 * TileW, 5 * TileW, vbSrcCopy
                                    'parent.picpreview.refresh
                                ElseIf tnr + i + 19 * j = 256 Then
                                    BitBlt parent.picpreview.hdc, (curtilex - lbx) * (parent.currenttilew), (curtiley - lby) * (parent.currenttilew), (parent.currenttilew), (parent.currenttilew), parent.picempty.hdc, 0, 0, vbSrcCopy
                                Else
                                    BitBlt parent.picpreview.hdc, (curtilex - lbx) * (parent.currenttilew), (curtiley - lby) * (parent.currenttilew), (parent.currenttilew), (parent.currenttilew), parent.piczoomtileset.hdc, ((tilenr + i + 19 * j - 1) Mod 19) * (parent.currenttilew), Int((tilenr + i + 19 * j - 1) / 19) * (parent.currenttilew), vbSrcCopy
                                End If
                            Else
                                If tilenr = 217 Then
                                    Call DrawRectangle(parent.picpreview, (curtilex - lbx), (curtilex - lbx + 1), (curtiley - lby), curtiley - lby + 1, TilePixelColor(tilenr + i + 19 * j))
                                ElseIf tilenr = 219 Then
                                    Call DrawRectangle(parent.picpreview, (curtilex - lbx - 2), (curtilex - lbx + 3), (curtiley - lby - 2), curtiley - lby + 3, TilePixelColor(tilenr + i + 19 * j))
                                ElseIf tilenr = 220 Then
                                    Call DrawRectangle(parent.picpreview, (curtilex - lbx - 2), (curtilex - lbx + 2), (curtiley - lby - 2), curtiley - lby + 2, TilePixelColor(tilenr + i + 19 * j))
                                Else
                                    Call SetPixel(parent.picpreview.hdc, (curtilex - lbx), (curtiley - lby), TilePixelColor(tilenr + i + 19 * j))
                                End If
                            End If
                        End If
                    End If
                End If
            End If
        Next
    Next
    'parent.picpreview.refresh
    
End Sub

Private Sub Swap(x As Integer, y As Integer)
    Dim tmp As Integer
    tmp = x
    x = y
    y = tmp

End Sub

Sub DrawTileRectangle(tilenr As Integer, startx As Integer, starty As Integer, endx As Integer, endy As Integer, undoch As Changes, multTileX As Integer, multTileY As Integer, Optional onpreview As Boolean = True, Optional filled As Boolean = False, Optional appendundo As Boolean = True, Optional step As Integer = 0, Optional tagwalltiles As Boolean = False)

    Dim i As Integer
    Dim j As Integer
    Dim oldendx As Integer
    Dim oldendy As Integer

    On Error GoTo DrawTileRectangle_Error

    If multTileX > step + 1 Then
        endx = startx + ((endx - startx) \ multTileX) * multTileX
    Else
        endx = startx + ((endx - startx) \ (step + 1)) * (step + 1)
    End If

    If multTileY > step + 1 Then
        endy = starty + ((endy - starty) \ multTileY) * multTileY
    Else
        endy = starty + ((endy - starty) \ (step + 1)) * (step + 1)
    End If


    Call DrawLine(tilenr, startx, starty, endx, starty, undoch, multTileX, multTileY, onpreview, False, appendundo, , step, tagwalltiles = True)
    Call DrawLine(tilenr, endx, starty, endx, endy, undoch, multTileX, multTileY, onpreview, False, appendundo, , step, tagwalltiles = True)
    Call DrawLine(tilenr, endx, endy, startx, endy, undoch, multTileX, multTileY, onpreview, False, appendundo, , step, tagwalltiles = True)
    Call DrawLine(tilenr, startx, endy, startx, starty, undoch, multTileX, multTileY, onpreview, False, appendundo, , step, tagwalltiles = True)

    If filled = True Then
        If startx <> endx And starty <> endy Then
            If startx > endx Then
                Swap startx, endx
            End If

            If starty > endy Then
                Swap starty, endy
            End If

            Dim correctStepX As Integer
            Dim correctStepY As Integer
            If multTileX > step + 1 Then
                correctStepX = multTileX
            Else
                correctStepX = step + 1
            End If

            If multTileY > step + 1 Then
                correctStepY = multTileY
            Else
                correctStepY = step + 1
            End If

            If Not onpreview Or tagwalltiles Then
                For j = starty + correctStepY To endy - correctStepY Step correctStepY
                    Call DrawLine(tilenr, startx + correctStepX, j, endx - correctStepX, j, undoch, multTileX, multTileY, onpreview, False, appendundo, True, step, tagwalltiles)
                Next
            End If
        End If
    End If

    If Not tagwalltiles Then
        If Not onpreview Then
            parent.UpdatePreview
        Else
            parent.picpreview.refresh
        End If
    End If


    On Error GoTo 0
    Exit Sub

DrawTileRectangle_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure DrawTileRectangle of Class Module Line"

End Sub

Sub DrawEllipse(tilenr As Integer, ByVal x As Integer, ByVal y As Integer, ByVal xx As Integer, ByVal yy As Integer, undoch As Changes, multTileX As Integer, multTileY As Integer, Optional onpreview As Boolean = True, Optional filled As Boolean, Optional appendundo As Boolean = True, Optional step As Integer = 0, Optional tagwalltiles As Boolean = False)
    Dim cx#, cy#, px#, py#, xp#, yp#
    Dim theta#, dtheta#, a#, b#
    Dim i As Integer
    Dim j As Integer

    
    On Error GoTo DrawEllipse_Error

    cx = x + (xx - x) / 2#
    cy = y + (yy - y) / 2#
    a = (xx - x) / 2#
    b = (yy - y) / 2#

    dtheta = 0.05

    For theta = 0# To 2 * 3.14 + dtheta Step dtheta
        xp = cx + a * Cos(theta)
        yp = cy + b * Sin(theta)
        
        'If xp < cx Then
        '    xp = xp + 0.01
        'Else
        '    xp = xp - 0.01
        'End If
        'If yp < cy Then
        '    yp = yp + 0.01
        'Else
        '    yp = yp - 0.01
        'End If
        
        If theta <> 0 Then
            Call DrawLine(tilenr, CInt(xp), CInt(yp), CInt(px), CInt(py), undoch, multTileX, multTileY, onpreview, False, appendundo, , step, tagwalltiles)
        End If

        px = xp
        py = yp
        

    Next theta

    If a = 0 Or b = 0 Then GoTo skip

    If x > xx Then
        Swap x, xx
    End If
    If y > yy Then
        Swap y, yy
    End If

    If filled = True Then
        If Not onpreview Or tagwalltiles Then
            For j = y To yy Step multTileY
                For i = x To xx Step multTileX
                    If ((((i - cx) ^ 2) / a ^ 2) + (((j - cy) ^ 2) / b ^ 2)) < 1 Then
                        Call DrawLine(tilenr, i, j, i, j, undoch, multTileX, multTileY, onpreview, False, , , step, tagwalltiles)
                    End If

                Next
            Next
        End If
    End If
skip:



    If Not tagwalltiles Then
        If Not onpreview Then
            parent.UpdatePreview
        Else
            parent.picpreview.refresh
        End If
    End If

    On Error GoTo 0
    Exit Sub

DrawEllipse_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure DrawEllipse of Class Module Line"

End Sub

